//--------------------------------------------------------
// Задайте имя для устрйства, что бы вам было легче его найти
// например #define HUB_NAME "Кухня"
#define HUB_NAME            "hous_home" // Имя для GyverHub и и ответа на DISCOVER
#define HUB_ICO             "☔"
//--------------------------------------------------------
#define ESP_UDP_PORT        (8888U)  // номер порта, который будет слушать UDP сервер во время работы лампы как в режиме WiFi точки доступа, так и в режиме WiFi клиента (лучше не менять)
#define MAX_EFF_GYVER       91       // Максимальное количество эффектов для совместимости со старыми лампами
#define MAX_UDP_BUFFER_SIZE (512U)   // максимальный размер буффера UDP сервера
//--------------------------------------------------------
// Количество IP адресов соседей, которым можно посылать команды 
#define MAX_IP              7       // Максимальное количество - 16 из за особенностей GHflags
//--------------------------------------------------------
// Иконки (icon unicode) 
//#define str_modul           "РЕЛЕ,ШИМ,LED,TIM"
#define str_modul           "⚡,☵,🌈,⏱"
#define hlp_modul           "Модули - Реле ШИМ WS2812 Timer"
#define str_dayofweek       "Вс,П,В,С,Ч,Пт,Сб" 

//--------------------------------------------------------
// Подключение дополнительных модулей. Ненужные закоментировать
//--------------------------------------------------------
// модуль module_GyverLamp.ino
// Добавляет запрос и сихронизацию
//#define GyverLamp   //включить/отключить модуль
#if defined (GyverLamp)
// Флаг синхронизации ламп с 0 на остальные
bool copy_to_all=true;
FS_(copy_to_all);
#endif
uint8_t effect=0;
//--------------------------------------------------------
// модуль module_Alarm.ino
// Максимальное количество будильников
#define MAX_ALARMS          5       //включить/отключить модуль
#define ALARM_MENU          "⏰"

//--------------------------------------------------------
// модуль module_G220.ino
// Количество реле
#define RELE_PIN            (1U)    //включить/отключить модуль
// Список пинов, к которым подключается реле в module_G220.ino  
// Для ESP-01 Пин 0 - GPIO0, 2 - GPIO2  {0} , {0,2}
// 1 - {0}; 2 - {0,2}
uint8_t pin_220[RELE_PIN]={0};

//--------------------------------------------------------
// модуль module_IR.ino
// для Wemos Пин D1 для ESP-01 - 2 - GPIO2
// Модуль для приема сигналов и любого ИК пульта
//#define IR_PIN              (5U)   //включить/отключить модуль  
// Максимальное количество IR команд (кнопок на пульте). Если пультов много, добавляйте
// #define MAX_IR              (20U)
#define IR_MENU           "⭕"
//--------------------------------------------------------
// модуль module_SR501.ino
// Датчик движения
#define SR501_PIN         (0U)      //включить/отключить модуль
#define MAX_SR501         (5U)      // Количество событий
//#define SR501_MENU         "❂"
#define SR501_MENU         "⚽"
//--------------------------------------------------------
// модуль module_Translater.ino в разработке
// пока не восстебован
//#define MAX_SENDS           3        // Максимальное количество адресов пересылки

//--------------------------------------------------------
// модуль module_Timer.ino 
// самый удачный модуль. 
// Умеет принимать команды от других модулей (сети), запускать таймеры, передавать команды другим
// Максимальное количество таймеров
#define MAX_TIMER           15      //включить/отключить модуль
//#define TIMER_MENU          "⏳"
#define TIMER_MENU          "⏱"

//--------------------------------------------------------
// модуль управления ШИМ сигналом
// Используется для LED подсветки
// #define  PWM_PIN 1             //включить/отключить модуль
// Список пинов, к которым подключается реле в module_PWM.ino
// Для ESP-01 Пин 0 - GPIO0, 2 - GPIO2  {0} , {0,2}
// 1 - {0}; 2 - {0,2}

//--------------------------------------------------------
// модуль WS2812
// Модуль управления светодиодной лентой
#define WS2812_PIN           (5U)      //включить/отключить модуль
//#define WS2812_MENU          "LED"
#define WS2812_MENU          "🌈"
// 1 - лента, 2 - матрица
// module_WS2812_1D.ino - 1, module_WS2812_2D.ino - 2
#define WS2812_D               2
//--------------------------------------------------------
// модуль module_DHT22.ino
// Модуль для снятия температуры и влажности
//#define DHT_PIN              (4U)     //включить/отключить модуль
#define MAX_DHT_22            10
#define DHT_MENU             "🌡💧"
//--------------------------------------------------------
//module_GButton.ino
// Одинокая кнопка (массив кнопок не делал)
#define BTN_PIN              (4U)       //включить/отключить модуль
#define BTN_MENU             "🔘"
#define MAX_G_Button           10       // Максимальное количество действий
//--------------------------------------------------------
//module_DFPlayer.ino
#define DFPlayer
#define MP3_TX_PIN            (12U)    // artuinio TX mp3 player RX (D6)
#define MP3_RX_PIN            (14U)    // artuinio RX mp3 player TX (D5)
#define DFP_MENU             "🔊"
//--------------------------------------------------------

//--------------------------------------------------------
// 
//--------------------------------------------------------
// Длинна переменной для команды
#define HUB_LEN 25                // Максимальная длинна команды
#define CMD_LEN HUB_LEN+1
//для ответа на запрос DISCOVER
#define DISCOVER "IP %u.%u.%u.%u:%u:" HUB_NAME

String main_menu="PULT,IP,";
char packetBuffer[MAX_UDP_BUFFER_SIZE]; // buffer to hold incoming packet
char inputBuffer[MAX_UDP_BUFFER_SIZE];

//GyverHub hub("MyDevices", HUB_NAME, "⚡");
GyverHub hub("MyDevices",HUB_NAME,HUB_ICO);
bool HUB_Update=false; 
uint16_t localPort = ESP_UDP_PORT;

WiFiUDP Udp;

WiFiUDP ntpUDP;
int hour = 1;
int minute = 0;
int dayofweek=0;

uint64_t ntp_update_time=0;
const long utcOffsetInSeconds = 10800;

NTPClient timeClient(ntpUDP, "pool.ntp.org",utcOffsetInSeconds);
bool eeprom_flag=false;

//--------------------------
String str_GHflags_IP="0";

struct struct_ip_addr{
  bool on_off;
  char ipchr[CMD_LEN];
  GHflags copy_attr;
  GHcolor col;
//  uint32_t col_hex=GH_AQUA;
};

struct_ip_addr ip_addr[MAX_IP];
FS_(ip_addr);
//--------------------------
struct struct_lamp_status{
  bool online;
  bool on_off;
  uint32_t last_input_udp=0;
  String name;
  uint8_t eff;
  uint8_t BRI;
  uint8_t SPD;
  uint8_t SCA;
};

struct_lamp_status lamp_status[MAX_IP];
