#if defined (MAX_ALARMS)

//--------------------------
struct struct_alarm{
  bool on_off=false;
  uint32_t alarm_time=0;
  char cmd[CMD_LEN];  // Посылаемая команда
  GHflags week=0;
  GHflags lamp=0;
  GHflags modul=0;
  GHflags timers=0;
  bool ok=true;
};

struct_alarm alarms[MAX_ALARMS];
FS_(alarms);
//--------------------------------------------------------
void setup_Alarms(){
  FS_LOAD(alarms); 
  main_menu+=ALARM_MENU;
  main_menu+=",";
}
//--------------------------------------------------------
void loop_Alarms(){
  FS_TICK(alarms); 
  EVERY_MS(1000)
  {
      FOR_j(0,MAX_ALARMS) 
        if (alarms[j].on_off)
         if (alarms[j].week.get(dayofweek))
          if (hour*60+minute==round(alarms[j].alarm_time/60)) {
               if (alarms[j].ok) {
                    // Рассылка сообщений
                    module_parsig(alarms[j].modul,alarms[j].cmd);
                    IP_parsig(alarms[j].lamp,alarms[j].cmd);
                    alarms[j].ok=false;
               }
          } else alarms[j].ok=true;
  }
}
//--------------------------------------------------------
void load_Alarms(){
   String CONFIG="";
   FOR_i(0,MAX_ALARMS) {
    CONFIG+="ALARM;"+String(i);
    if (alarms[i].on_off) CONFIG+=";1;";
                     else CONFIG+=";0;";
    CONFIG+=String(alarms[i].alarm_time/3600)+":"+String((alarms[i].alarm_time/60)%60)+";";
    CONFIG+=alarms[i].week.toString()+";"+alarms[i].lamp.toString()+";"+alarms[i].modul.toString()+";"+String(alarms[i].cmd)+char(10);
   }
   Udp.write(CONFIG.c_str());
   Udp.write(char(10));
}
//--------------------------------------------------------
void HUB_module_Alarm() {
  static uint8_t tab = 0;
  static uint8_t plus_minus[MAX_ALARMS];
  FOR(tab,0,MAX_ALARMS) { 
    hub.WidgetSize(30);
    eeprom_flag |= hub.Switch(&alarms[tab].on_off,F("Включить"));
    hub.WidgetSize(40);
    eeprom_flag |= hub.Time(&alarms[tab].alarm_time, F("Alarm"), alarms[tab].on_off ?  GH_GREEN : GH_YELLOW);
    hub.WidgetSize(30);
    hub.Tabs(&plus_minus[tab]," - , + ");
    if (plus_minus[tab]) {
      hub.WidgetSize(100);
      eeprom_flag |= hub.Flags(&alarms[tab].week, str_dayofweek,F("Дни недели"));
      hub.WidgetSize(75);
      eeprom_flag |= hub.Input(&alarms[tab].cmd, GH_CSTR, F("Акция будильника"),HUB_LEN);
      hub.WidgetSize(25);
      if (hub.ButtonIcon(0, F("👉"))) {
          module_parsig(alarms[tab].modul,alarms[tab].cmd);
          IP_parsig(alarms[tab].lamp,alarms[tab].cmd);
      }
      hub.WidgetSize(100);
      eeprom_flag |= hub.Flags(&alarms[tab].lamp, str_GHflags_IP,F("Устройства"));
      eeprom_flag |= hub.Flags(&alarms[tab].modul, str_modul,F(hlp_modul));
    }
  }
  if (eeprom_flag) {
      FS_UPDATE(alarms);
      eeprom_flag=false;
   }
}
//----------------------------------
void parsing_Alarm(char act_chr[]){
  String strBuffer=String(act_chr);
  String strCommand=getValue(strBuffer,';',0);
  //--------
  if (strCommand=="ALARM") {
      String byte_str=getValue(strBuffer,';',1);
      int i = byte_str.toInt();
      if (i<MAX_ALARMS) {
          String argBuffer=getValue(strBuffer,';',2);
          alarms[i].on_off=(argBuffer.toInt()==1);
          argBuffer=getValue(strBuffer,';',3);
          String strh=getValue(argBuffer,':',0);
          String strm=getValue(argBuffer,':',1);
          alarms[i].alarm_time=(strh.toInt()*60+strm.toInt())*60;
          argBuffer=getValue(strBuffer,';',4); // День недели
          FOR_j(0,7) {
           if (argBuffer[j]=='1') alarms[i].week.set(j,1);
              else alarms[i].week.set(j,0);
          }
          argBuffer=getValue(strBuffer,';',5); // IP лампы
          FOR_j(0,16) {
           if (argBuffer[j]=='1') alarms[i].lamp.set(j,1);
              else alarms[i].lamp.set(j,0);
          }
          argBuffer=getValue(strBuffer,';',6); // модули
          FOR_j(0,16) {
           if (argBuffer[j]=='1') alarms[i].modul.set(j,1);
              else alarms[i].modul.set(j,0);
          }
          argBuffer=getValue(strBuffer,';',7); // cmd
          strcpy(alarms[i].cmd,argBuffer.c_str());
          FS_UPDATE(alarms);
       }
   }
  //--------
}
//----------------------------------
#endif
