//Модуль упраление ИК пультом

//Если ИК отсутствует, отключите
//#define IR_PIN            (5U)      // для Wemos Пин D1 перенесено в define.h
//#define IR_PIN              4       // для Wemos Пин D2 , куда подключет IR 
//#define IR_PIN              2       // Для ESP-01 Пин GPIO2
#if defined (IR_PIN)

#include <IRremoteESP8266.h>
#include <IRrecv.h>
#include <IRutils.h>
//--------------------------------------------------------
struct struct_IR_pult{
  bool on_off;
  char cmd[CMD_LEN]; // Посылаемая команда
  uint32_t code=0;
  GHflags lamp=0;
  GHflags modul=0;
  GHflags timers=0;
  bool repeat;
};

struct_IR_pult IR_pult[MAX_IR];
FS_(IR_pult);
//--------------------------------------------------------

IRrecv irrecv(IR_PIN);
decode_results results;
int64_t IR_last_press;
int64_t IR_press;
String IR_str="IR";
bool pressed;

//--------------------------------------------------------
void setup_IR(){
  irrecv.enableIRIn();
  FS_LOAD(IR_pult); 
  main_menu+=IR_MENU;
  main_menu+=",";
}

//--------------------------------------------------------
void loop_IR() {
  if ( irrecv.decode( &results )) {   // если данные пришли
      IR_str=String(uint32_t(results.value),HEX);
      DEBUGLN(IR_str);
      if (results.value != -1) {
         pressed=false;
         IR_press=results.value;
 
         FOR_i(0,MAX_IR) {
          //Записать команду в свободную включенную ячейку
           if (IR_pult[i].on_off)
            if (IR_pult[i].code==0) {
              IR_pult[i].code=IR_press;
              FS_UPDATE(IR_pult);
              if (hub.focused() && HUB_Update) {
                  hub.sendUpdate("code"+String(i), IR_str);
                  HUB_Update=false;
              }
            }
         }
      } else IR_press=-1;
      FOR_j(0,MAX_IR) {
           if (IR_pult[j].on_off) {
              if (IR_press==-1) IR_press=IR_last_press;
              if ((IR_pult[j].code==IR_press) || (IR_pult[j].code==0xFFFFFFFF)) {
                if (IR_pult[j].repeat) IR_last_press = IR_press; else IR_last_press = -1;
//                DEBUG(String(uint32_t(IR_pult[j].code),HEX)); DEBUG(" ");  DEBUGLN(IR_pult[j].cmd);
                FOR_i(0,MAX_IP) if (IR_pult[j].lamp.get(i)) if (ip_addr[i].on_off) {
                   char IR_Action[CMD_LEN];
                   strcpy(IR_Action, IR_pult[j].cmd);
                   if (!strcmp(IR_Action,"IRx"))  sprintf_P(IR_Action,"IR %x",IR_press); else
                   if (!strcmp(IR_Action,"IR"))   sprintf_P(IR_Action,"IR %u",IR_press); else
#if defined (GyverLamp)
                   if (!strcmp(IR_Action,"ON_OFF")){
                      if (lamp_status[i].on_off) strcpy(IR_Action,"P_OFF"); else strcpy(IR_Action,"P_ON");
                      } else
                   if (!strcmp(IR_Action,"EFF+")) sprintf_P(IR_Action,"EFF%u",lamp_status[i].eff++ % MAX_EFF_GYVER); else
                   if (!strcmp(IR_Action,"EFF-")) sprintf_P(IR_Action,"EFF%u",(lamp_status[i].eff-- + MAX_EFF_GYVER) % MAX_EFF_GYVER); else
                   if (!strcmp(IR_Action,"BRI+")) sprintf_P(IR_Action,"BRI%u",lamp_status[i].BRI++); else
                   if (!strcmp(IR_Action,"BRI-")) sprintf_P(IR_Action,"BRI%u",lamp_status[i].BRI--); else
                   if (!strcmp(IR_Action,"SPD+")) sprintf_P(IR_Action,"SPD%u",lamp_status[i].SPD++); else
                   if (!strcmp(IR_Action,"SPD-")) sprintf_P(IR_Action,"SPD%u",lamp_status[i].SPD--); else
                   if (!strcmp(IR_Action,"SCA+")) sprintf_P(IR_Action,"SCA%u",lamp_status[i].SCA++ % 101); else
                   if (!strcmp(IR_Action,"SCA-")) sprintf_P(IR_Action,"SCA%u",(lamp_status[i].SCA-- + 101) % 101); else
#endif
                   delay(0);  // заглушка else
                   DEBUGLN(IR_Action);

                   module_parsig(IR_pult[j].modul,IR_Action);
                   send_console(ip_addr[i].ipchr,IR_Action);
                }
              }
           }   
      }

//           IR_last_press=IR_press;
    irrecv.resume();  // принимаем следующую команду
  }
  FS_TICK(IR_pult); 
}
//--------------------------------------------------------
void HUB_module_IR() {
  static uint8_t plus_minus[MAX_IR];
  static uint8_t tab = 0;


 FOR(tab,0,MAX_IR) { 
  hub.WidgetSize(20);
  eeprom_flag |= hub.Switch_("sw_IR"+String(tab),&IR_pult[tab].on_off,F("Active"));
  hub.WidgetSize(40);
  String IR_HEX=String(IR_pult[tab].code,HEX);
  if (hub.Input_("code"+String(tab),&IR_HEX,GH_STR,"HEX Code",8,F("^[A-Fa-f0-9]+$"))) {
      IR_HEX="0x"+IR_HEX;
      DEBUG(IR_HEX + " : ");
      IR_pult[tab].code = strtoul(IR_HEX.c_str(), 0, 16);
      DEBUGLN(IR_pult[tab].code);
      eeprom_flag=true;
  }
  hub.WidgetSize(20);
  eeprom_flag |= hub.Switch(&IR_pult[tab].repeat,F("Повтор 0xFFFFFF"));
  hub.Tabs(&plus_minus[tab]," - , + ");
  if (plus_minus[tab]) {

    hub.WidgetSize(100);
    eeprom_flag |= hub.Input(&IR_pult[tab].cmd, GH_CSTR, F("Акция IR пульта"),HUB_LEN);
    hub.WidgetSize(100);
    eeprom_flag |= hub.Flags(&IR_pult[tab].lamp, str_GHflags_IP,F("Устройства"));
    eeprom_flag |= hub.Flags(&IR_pult[tab].modul, str_modul,F(hlp_modul));
  }
 }  
     if (eeprom_flag) {
      FS_UPDATE(IR_pult);
      eeprom_flag=false;
   }
/*   
  hub.Display("\
ON_OFF - Включить/Выключить\n\
EFF+  - Следующий эффект\n\
EFF-  - Предыдущий эффект\n\
BRI+  - Увеличить яркость\n\
BRI-  - Уменьшить яркость\n\
IR    - Переслать IR код с пульта\n\
IRx   - Переслать HEX код с пульта\n\
\n\
Остальные команды без изменений\n\
","Встроенные акциии",GH_DEFAULT, 12, 18);
*/
}
//--------------------------------------------------------
void load_IR(){
   String CONFIG="";
   FOR_i(0,MAX_IR) {
    CONFIG+="IR;"+String(i);
    if (IR_pult[i].on_off) CONFIG+=";1;";
                      else CONFIG+=";0;";
    CONFIG+=String(IR_pult[i].code,HEX)+";";
    CONFIG+=IR_pult[i].lamp.toString()+";"+IR_pult[i].modul.toString()+";"+IR_pult[i].repeat+";"+String(IR_pult[i].cmd)+char(10);
   }
   Udp.write(CONFIG.c_str());
   Udp.write(char(10));
}
#endif
