#if defined (MAX_TIMER)

//--------------------------------------------------------
struct struct_TIMER{
  bool on_off;
  char cmd_in[CMD_LEN];
  char cmd_start[CMD_LEN];
  char cmd_active[CMD_LEN];
  char cmd[CMD_LEN];
  uint32_t time_from=0;
  uint32_t time_to=0;
  GHflags week=255;
  GHflags lamp=0;
  GHflags modul=0;
  uint32_t timer=15; //15 минут по умолчанию
  uint32_t tik_tik=0;
  bool ok=true;
};
struct_TIMER TIMER[MAX_TIMER];
FS_(TIMER);
//--------------------------------------------------------
void setup_TIMER(){
  strcpy(TIMER[0].cmd_in, "STARTUP");
  FS_LOAD(TIMER); 
  FOR(tab,0,MAX_TIMER) TIMER[tab].on_off=false;
  main_menu+=TIMER_MENU;
  main_menu+=",";
}
//--------------------------------------------------------
void hub_update_loop_TIMER(){
// if (hub.focused()) 
  FOR_i(0,MAX_TIMER)
    if (TIMER[i].on_off)
      {
         String h_s;
         String h_m;
         h_s=String(((TIMER[i].tik_tik-millis())/1000)%60);
         h_m=String((TIMER[i].tik_tik-millis())/60000);
         if (((TIMER[i].tik_tik-millis())/1000)%60<10) h_s="0"+h_s;
         if (hub.focused()) {
            hub.sendUpdate("tik_TIM"+String(i), h_m+":"+h_s);
            hub.sendUpdate("sw_TIM"+String(i), "1");
            HUB_Update=false;
         }
      }
       else 
         if (hub.focused() && HUB_Update) {
            hub.sendUpdate("tik_TIM"+String(i), "0");
            hub.sendUpdate("sw_TIM"+String(i), "0");
            HUB_Update=false;
         }
}
//--------------------------------------------------------
void send_on_time(uint8_t i, char act[]) {
 if (strlen(act))
   if (TIMER[i].week.get(dayofweek)) {
     bool on_time=false;
     if (TIMER[i].time_from<TIMER[i].time_to) 
         on_time=(hour*60+minute>=round(TIMER[i].time_from/60)) && (hour*60+minute<=round(TIMER[i].time_to/60));
     else    
         on_time=(hour*60+minute>=round(TIMER[i].time_from/60)) || (hour*60+minute<=round(TIMER[i].time_to/60));
     if (on_time) {
           module_parsig(TIMER[i].modul,act);
           IP_parsig(TIMER[i].lamp,act);
     }
   }   
}
//--------------------------------------------------------
void loop_TIMER(){
  EVERY_MS(1000) {
  FS_TICK(TIMER); 
  FOR_i(0,MAX_TIMER) 
    if (TIMER[i].on_off) {
      
      if (TIMER[i].tik_tik<millis())
      {
        TIMER[i].on_off=false;
        TIMER[i].tik_tik=0;
        send_on_time(i,TIMER[i].cmd);
        HUB_Update=true;
      } else {
        if (TIMER[i].ok) {  //запуск таймера
           send_on_time(i,TIMER[i].cmd_start);
           TIMER[i].ok=false;
           HUB_Update=true;
        }
        send_on_time(i,TIMER[i].cmd_active);
      }
    } else TIMER[i].ok=true;
    hub_update_loop_TIMER();
  }
}

//--------------------------------------------------------
void parsing_TIMER(char act_chr[]){
    String act=String(act_chr);
    act.toUpperCase();
    String strCommand=getValue(act,' ',0);
    if ((strCommand=="TIMER") || (strCommand=="TIM")){
       String argstr = getValue(act,' ',1);
       uint8_t argint=argstr.toInt();
       argstr = getValue(act,' ',3);
       uint8_t argint1=argstr.toInt();
       if (argint1>0) TIMER[argint].timer=argint;
       TIMER_Start(argint,getValue(act,' ',2)=="ON");
    }
  FOR(i,0,MAX_TIMER) if (!strcmp(act_chr,TIMER[i].cmd_in)) TIMER_Start(i,true);
}
//--------------------------------------------------------
void TIMER_Start(uint8_t tim,bool ON_OFF) {
  if (tim<MAX_TIMER) {
    TIMER[tim].on_off=ON_OFF;
    TIMER[tim].tik_tik=millis()+TIMER[tim].timer*60000;
    if (ON_OFF) send_on_time(tim,TIMER[tim].cmd_start);
    HUB_Update=true;
  }
}
//--------------------------------------------------------
void HUB_module_pult_TIMER() {
  FOR_i(0,MAX_TIMER) 
   if (TIMER[i].on_off || strlen(TIMER[i].cmd_in)){
    hub.WidgetSize(48);
    hub.Display(TIMER[i].cmd_in,"Имя "+String(i)+" таймера",GH_DEFAULT, 1, 18);
    hub.WidgetSize(26);
    hub.Display_("tik_TIM"+String(i),F("0"),"оставшееся время до "+String(TIMER[i].cmd),GH_DEFAULT, 1, 18);
    hub.WidgetSize(26);
    if (hub.Switch_("sw_TIM"+String(i),&TIMER[i].on_off,F("Active"))) TIMER_Start(i,TIMER[i].on_off);
  }
}
//--------------------------------------------------------
void HUB_module_TIMER() {
  static uint8_t plus_minus[MAX_TIMER];
  String h_m;
  String h_s;
  
  FOR(tab,0,MAX_TIMER) {
     hub.WidgetSize(20);
     if (hub.Switch_("sw_TIM"+String(tab),&TIMER[tab].on_off,String(tab)+". Active")) TIMER_Start(tab,TIMER[tab].on_off);
     hub.WidgetSize(60);
     eeprom_flag |= hub.Input(&TIMER[tab].cmd_in, GH_CSTR, F("Имя таймера / Условие"),15);
     hub.WidgetSize(20);
     hub.Tabs(&plus_minus[tab]," - , + ");
     if (plus_minus[tab]) {
         hub.WidgetSize(50);
         eeprom_flag |= hub.Input(&TIMER[tab].timer,GH_INT16, "Таймер "+String(tab));
         hub.Display_("tik_TIM"+String(tab),F("0"),"оставшееся время",GH_DEFAULT, 1, 18);
         eeprom_flag |= hub.Time(&TIMER[tab].time_from, F("From"));
         eeprom_flag |= hub.Time(&TIMER[tab].time_to, F("To"));
         hub.WidgetSize(100);
         eeprom_flag |= hub.Flags(&TIMER[tab].week, str_dayofweek,F("Дни недели"));
         eeprom_flag |= hub.Input(&TIMER[tab].cmd_start, GH_CSTR, F("Команда при старте"),HUB_LEN,"",GH_GREEN);
         eeprom_flag |= hub.Input(&TIMER[tab].cmd_active, GH_CSTR, F("Команда при активности"),HUB_LEN,"",GH_GREEN);
         eeprom_flag |= hub.Input(&TIMER[tab].cmd, GH_CSTR, F("Команда на финише"),HUB_LEN,"",GH_RED);
         eeprom_flag |= hub.Flags(&TIMER[tab].lamp, str_GHflags_IP,F("Устройства"));
         eeprom_flag |= hub.Flags(&TIMER[tab].modul, str_modul,F(hlp_modul));
     }
  }
  if (eeprom_flag) {
      FS_UPDATE(TIMER);
      eeprom_flag=false;
//      DEBUGLN("Timer Update");
  }
}
//--------------------------------------------------------
void load_TIMER(){

}
#endif
