#if defined (WS2812_PIN)
#if (WS2812_D==2)  // Матрица

#include <FastLED.h>

#define MIN_WIDTH                 (5U)                          // ширина матрицы
#define MIN_HEIGHT                (5U)                          // высота матрицы
#define MAX_WIDTH                 (25U)                         // ширина матрицы
#define REG_WIDTH                 "^([5-9]|1[0-9]|2[0-5]){1}$"  // Регулярное выражение от 5 до 25
#define MAX_HEIGHT                (25U)                         // высота матрицы
#define REG_HEIGHT                 "^([5-9]|1[0-9]|2[0-5]){1}$" // Регулярное выражение от 5 до 25
uint8_t WIDTH = 16;                                             // ширина матрицы
uint8_t HEIGHT = 16;                                            // высота матрицы

struct {
  uint8_t WIDTH = 16;                                             // ширина матрицы
  uint8_t HEIGHT = 16;                                           // высота матрицы
  uint8_t BRI=10;
  uint8_t SPD=128;
  uint8_t SCA=128;
  uint8_t CLR=0;
} Matrix;
FS_(Matrix);

static const uint8_t maxDim = max(MAX_WIDTH, MAX_HEIGHT);

uint16_t x;
uint16_t y;
uint16_t z;

#define MAX_DIMENSION (max(MAX_WIDTH, MAX_HEIGHT))
#if (MAX_WIDTH > MAX_HEIGHT)
uint8_t noise[MAX_WIDTH][MAX_WIDTH];
#else
uint8_t noise[MAX_HEIGHT][MAX_HEIGHT];
#endif


#define NUM_LEDS    MAX_WIDTH*MAX_HEIGHT // Количество светодиодов в матрице

#define MAX_EFF     33 //Количество эффектов. требуется для зацикливания EFF +/-

//Список эффетов
#define NAME_EFF   "Цвет,Цветоворот,Радуга,Камин,Хаос,\
Облака,Лава,Плазма,Многоцветие,Павлин,Лес,Океан,Апельсин,Огонь,Пламя,Литий,Лимон,Трава,Небо,Рубидий,Калий,Зебра,\
Дождь,Радождь,Снег,Дражже,Цветочек,Конфети,Мерцание,Дожди,Звездопад,Метель,Люмeньep"



uint16_t speed = 20;     // speed is set dynamically once we've started up
uint16_t scale = 30;     // scale is set dynamically once we've started up

uint8_t colorLoop = 1;
uint8_t hue = 0;
uint8_t rassvet=0;
uint8_t length_rassvet = 10; // 10 минут
extern const TProgmemRGBPalette16 WaterfallColors_p FL_PROGMEM = {CRGB::Black, 0x060707, 0x101110, 0x151717, 0x1C1D22, 0x242A28, 0x363B3A, 0x313634, 0x505552, 0x6B6C70, 0x98A4A1, 0xC1C2C1, 0xCACECF, 0xCDDEDD, 0xDEDFE0, 0xB2BAB9};
extern const TProgmemRGBPalette16 WoodFireColors_p FL_PROGMEM = {CRGB::Black, 0x330e00, 0x661c00, 0x992900, 0xcc3700, CRGB::OrangeRed, 0xff5800, 0xff6b00, 0xff7f00, 0xff9200, CRGB::Orange, 0xffaf00, 0xffb900, 0xffc300, 0xffcd00, CRGB::Gold};             //* Orange
extern const TProgmemRGBPalette16 NormalFire_p FL_PROGMEM = {CRGB::Black, 0x330000, 0x660000, 0x990000, 0xcc0000, CRGB::Red, 0xff0c00, 0xff1800, 0xff2400, 0xff3000, 0xff3c00, 0xff4800, 0xff5400, 0xff6000, 0xff6c00, 0xff7800};                             //* Огонь 
extern const TProgmemRGBPalette16 NormalFire2_p FL_PROGMEM = {CRGB::Black, 0x560000, 0x6b0000, 0x820000, 0x9a0011, CRGB::FireBrick, 0xc22520, 0xd12a1c, 0xe12f17, 0xf0350f, 0xff3c00, 0xff6400, 0xff8300, 0xffa000, 0xffba00, 0xffd400};                      //* Огонь с желтизной 
extern const TProgmemRGBPalette16 LithiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x240707, 0x470e0e, 0x6b1414, 0x8e1b1b, CRGB::FireBrick, 0xc14244, 0xd16166, 0xe08187, 0xf0a0a9, CRGB::Pink, 0xff9ec0, 0xff7bb5, 0xff59a9, 0xff369e, CRGB::DeepPink};        //* Red
extern const TProgmemRGBPalette16 SodiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x332100, 0x664200, 0x996300, 0xcc8400, CRGB::Orange, 0xffaf00, 0xffb900, 0xffc300, 0xffcd00, CRGB::Gold, 0xf8cd06, 0xf0c30d, 0xe9b913, 0xe1af1a, CRGB::Goldenrod};           //* Yellow
extern const TProgmemRGBPalette16 GrassFireColors_p FL_PROGMEM = {CRGB::Black, 0x001a00, 0x003300, 0x004d00, 0x006600, CRGB::Green, 0x239909, 0x45b313, 0x68cc1c, 0x8ae626, CRGB::GreenYellow, 0x94f530, 0x7ceb30, 0x63e131, 0x4bd731, CRGB::LimeGreen};     //* Green
extern const TProgmemRGBPalette16 SkyFireColors_p FL_PROGMEM = {CRGB::Black, 0x000033, 0x000066, 0x000099, 0x0000cc, CRGB::Blue, 0x0026ff, 0x004cff, 0x0073ff, 0x0099ff, CRGB::DeepSkyBlue, 0x1bc2fe, 0x36c5fd, 0x51c8fc, 0x6ccbfb, CRGB::LightSkyBlue};  //* Blue
extern const TProgmemRGBPalette16 RubidiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x0f001a, 0x1e0034, 0x2d004e, 0x3c0068, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, 0x3c0084, 0x2d0086, 0x1e0087, 0x0f0089, CRGB::DarkBlue};        //* Indigo
extern const TProgmemRGBPalette16 PotassiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x0f001a, 0x1e0034, 0x2d004e, 0x3c0068, CRGB::Indigo, 0x591694, 0x682da6, 0x7643b7, 0x855ac9, CRGB::MediumPurple, 0xa95ecd, 0xbe4bbe, 0xd439b0, 0xe926a1, CRGB::DeepPink}; //* Violet
extern const TProgmemRGBPalette16 ZebraColors_p FL_PROGMEM = {CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black}; //* Zebra
//Раскраски стран
extern const TProgmemRGBPalette16 RBColors_p FL_PROGMEM = {CRGB::Black, CRGB::White, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Green, CRGB::Green, CRGB::Green, CRGB::Green, CRGB::Green, CRGB::Green  }; //* РБ
extern const TProgmemRGBPalette16 RUColors_p FL_PROGMEM = {CRGB::Black, CRGB::White, CRGB::White, CRGB::White, CRGB::White, CRGB::White, CRGB::Blue, CRGB::Blue, CRGB::Blue, CRGB::Blue, CRGB::Blue, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red, CRGB::Red }; //* РФ

// Набор палитр для эффектов "Сияние" "Дожди"
const TProgmemRGBPalette16 *FullPalettes[] = {
  &NormalFire_p,
  &NormalFire2_p,
  &HeatColors_p,
  &LavaColors_p,
  &WoodFireColors_p,
  &SodiumFireColors_p,
  &ForestColors_p,
  &GrassFireColors_p,
  &SkyFireColors_p,
  &CloudColors_p,
  &OceanColors_p,
  &WaterfallColors_p,
  &RubidiumFireColors_p,
  &PotassiumFireColors_p,
  &LithiumFireColors_p,
  &RainbowColors_p,
  &RainbowStripeColors_p,
  &PartyColors_p,
  &RBColors_p,
  &RUColors_p
};
// Набор палитр для эффекта "Камин"
const TProgmemRGBPalette16 *firePalettes[] = {
  &NormalFire_p,
  &NormalFire2_p,
  &HeatColors_p,
  &LavaColors_p,
  &WoodFireColors_p,
  &SodiumFireColors_p,
  &GrassFireColors_p,
  &SkyFireColors_p,
  &WaterfallColors_p,
  &RubidiumFireColors_p,
  &PotassiumFireColors_p,
  &LithiumFireColors_p
//  &RainbowColors_p
//  &RainbowStripeColors_p,
//  &RBColors_p,
//  &RUColors_p
};

const TProgmemRGBPalette16 *curPalette = firePalettes[0];

CRGBPalette16 currentPalette(PartyColors_p);

uint8_t Real_EFF = 0;
bool Power_EFF = false;
uint8_t BRI=10;
uint8_t SPD=128;
uint8_t SCA=128;
uint8_t CLR=0;

CRGB leds[NUM_LEDS];  
CRGB ledsbuff[NUM_LEDS];                           // копия массива leds[] целиком

uint8_t CENTER_X_MINOR =  (WIDTH / 2) -  ((WIDTH - 1) & 0x01); // центр матрицы по ИКСУ, сдвинутый в меньшую сторону, если ширина чётная
uint8_t CENTER_Y_MINOR = (HEIGHT / 2) - ((HEIGHT - 1) & 0x01); // центр матрицы по ИГРЕКУ, сдвинутый в меньшую сторону, если высота чётная
uint8_t CENTER_X_MAJOR =   WIDTH / 2  + (WIDTH % 2);           // центр матрицы по ИКСУ, сдвинутый в большую сторону, если ширина чётная
uint8_t CENTER_Y_MAJOR =  HEIGHT / 2  + (HEIGHT % 2);          // центр матрицы по ИГРЕКУ, сдвинутый в большую сторону, если высота чётная
#define NUM_LAYERSMAX 2
uint8_t noise3d[NUM_LAYERSMAX][MAX_WIDTH][MAX_HEIGHT];     // двухслойная маска или хранилище свойств в размер всей матрицы


//--------------------------------------------------------
//Заготовка, если параметры нужны для каждого еффекта отдельно
struct struct_WS2812{
  bool on_off;
//  char cmd[15];
  uint8_t BRI=20;
  uint8_t SPD=128;
  uint8_t SCA=128;
  uint8_t CLR=0;
  bool    FAV=true;
  bool ok=true;
};
//struct_WS2812 WS2812_R[MAX_EFF];
//FS_(WS2812_R);
//--------------------------------------------------------
void from_Matrix() {
  WIDTH  =  Matrix.WIDTH;
  HEIGHT =  Matrix.HEIGHT;
  BRI    =  Matrix.BRI;
  SPD    =  Matrix.SPD;
  SCA    =  Matrix.SCA;
  CLR    =  Matrix.CLR;
}  
void to_Matrix() {
  Matrix.WIDTH  =  WIDTH;
  Matrix.HEIGHT =  HEIGHT;
  Matrix.BRI    =  BRI;
  Matrix.SPD    =  SPD;
  Matrix.SCA    =  SCA;
  Matrix.CLR    =  CLR;
}  
void setup_WS2812(){
//  FS_LOAD(WS2812_R); 
//  FastLED.addLeds<WS2812, WS2812_PIN, BRG>(leds, NUM_LEDS);  // инициализация светодиодов (RGB,BRG - порядок цветов)
FS_LOAD(Matrix);
from_Matrix();
FastLED.addLeds<WS2812, WS2812_PIN, GRB>(leds, NUM_LEDS);  // инициализация светодиодов (RGB,BRG - порядок цветов) 
CENTER_XY();
  main_menu+=WS2812_MENU;
  main_menu+=",";
}
//--------------------------------------------------------
#define EFFECT_N(x,clp) \
currentPalette=(x);\
colorLoop = (clp);\
fillNoiseLED();\


void loop_WS2812(){
//  FS_TICK(WS2812_R); 
  FS_TICK(Matrix);
  FastLED.setBrightness(BRI);
  EVERY_MS(256U-SPD) 
  if (rassvet) Rassvet();
  else if (Power_EFF)
  switch (Real_EFF) {
    case 0: LEDS.showColor(CHSV(CLR,SCA,255));  break; // Цвет7
    case 1: LEDS.showColor(CHSV(hue++,SCA,255)); break; // Цветоворот
    case 2: effect_rainbow();                   break; // Радуга
    case 3: fire2020Routine2();                 break; // Камин
// ---------------Noise 
    case 4: NoiseRoutine();                     break; // Хаос
    case 5: EFFECT_N(CloudColors_p,0)           break; // Oблaкa
    case 6: EFFECT_N(LavaColors_p,0)            break; // Лaвa 
    case 7: EFFECT_N(PartyColors_p,1)           break; // Плазма 
    case 8: EFFECT_N(RainbowColors_p,1)         break; // Многоцветие
    case 9: EFFECT_N(RainbowStripeColors_p,1)   break; // Пaвлин
    case 10: EFFECT_N(ForestColors_p,0)          break; // Лес
    case 11: EFFECT_N(OceanColors_p,0)          break; // Океан
    case 12: EFFECT_N(WoodFireColors_p,0)       break; // Апельсин
    case 13: EFFECT_N(NormalFire_p,0)           break; // Огонь
    case 14: EFFECT_N(NormalFire2_p,0)          break; // Пламя
    case 15: EFFECT_N(LithiumFireColors_p,0)    break; // Литий
    case 16: EFFECT_N(SodiumFireColors_p,0)     break; // Лимон
    case 17: EFFECT_N(GrassFireColors_p,0)      break; // Трава
    case 18: EFFECT_N(SkyFireColors_p,0)        break; // Небо
    case 19: EFFECT_N(RubidiumFireColors_p,0)   break; // Рубидий
    case 20: EFFECT_N(PotassiumFireColors_p,0)  break; // Калий
    case 21: EFFECT_N(ZebraColors_p,0)          break; // Зебра
// -----------------------    
    case 22: RainRoutine(0);                    break; // Дождь
    case 23: RainRoutine(1);                    break; // Радождь
    case 24: RainRoutine(2);                    break; // Снег
    case 25: sandRoutine();                     break; // Дражже
    case 26: FlowerRuta();                      break; // Цветочек
    case 27: sparklesRoutine();                 break; // Конфети
    case 28: twinklesRoutine();                 break; // Мерцание
    case 29: RainRoutine(3);                    break; // Дожди (через палитру)
    case 30: stormRoutine(3);                   break; // Звездопад (через палитру)
    case 31: stormRoutine(2);                   break; // Метель
    case 32: lumenjerRoutine();                 break; // Люмeньep

} else {
    LEDS.showColor(CRGB(0,0,0));
    rassvet=0;
  }
}
//--------------------------------------------------------
void parsing_WS2812(char act_chr[]){
    String act=String(act_chr);
    bool Old_Power_EFF=Power_EFF;
    FOR_i(0,MAX_EFF) act.replace(getValue(NAME_EFF,',',i), "EFF "+String(i));
    DEBUG("Modul WS2812 : ");
    DEBUGLN(act);
    String strCommand=getValue(act,' ',0);
    String strParam=getValue(act,' ',1);
    strCommand.toUpperCase();
    strParam.toUpperCase();
    uint8_t intParam=str_to_int(strParam);
    if ((strCommand=="Рассвет") || (strCommand=="РАССВЕТ")){
      length_rassvet=10;
      if (strParam == "OFF") rassvet=0; else
      if ((strParam=="ON_OFF") || (strParam=="SWITCH")) { 
          if (rassvet==0) rassvet=1; else rassvet=0; 
      } else {
        if (strParam>"") length_rassvet=intParam; 
        rassvet=1;
      }  
      Power_EFF = rassvet;
    } else
    if (strCommand=="BRI") {
      if (strParam == "+") (BRI<255) ? BRI++ : 255 ; else
      if (strParam == "-") (BRI>0) ? BRI-- : 0 ; else
      BRI = intParam; 
      if (BRI) Power_EFF = true;
      HUB_Update=true;
    } else
    if (strCommand=="SPD") {
      if (strParam == "+") (SPD<255) ? SPD++ : 255 ; else
      if (strParam == "-") (SPD>0) ? SPD-- : 0 ; else
      SPD = intParam; 
      HUB_Update=true;
    } else
    if (strCommand=="CLR") { // Цвет по кругу.
      if (strParam == "+") CLR++; else
      if (strParam == "-") CLR--; else
      CLR = intParam; 
      HUB_Update=true;
    } else

    if ((strCommand=="SET") || (strCommand=="EFF")) {   // команда SET eff bri spd sca clr
      if (strParam == "+") Real_EFF = (Real_EFF+1) % MAX_EFF; else
      if (strParam == "-") Real_EFF = (MAX_EFF+Real_EFF-1) % MAX_EFF; else
      if (intParam < MAX_EFF) {Real_EFF = intParam; Power_EFF = true; }
      strParam=getValue(act,' ',2);
      intParam=str_to_int(strParam);
      if ((strParam > "") && (strParam != "*")){ 
          BRI=intParam;
          if (BRI) Power_EFF = true;
          DEBUGLN(BRI);
          }
      strParam=getValue(act,' ',3);
      intParam=str_to_int(strParam);
      if ((strParam > "") && (strParam != "*")) SPD=intParam;
      strParam=getValue(act,' ',4);
      intParam=str_to_int(strParam);
      if ((strParam > "") && (strParam != "*")) SCA=intParam;
      strParam=getValue(act,' ',5);
      intParam=str_to_int(strParam);
      if ((strParam > "") && (strParam != "*")) CLR=intParam;
      HUB_Update=true;
    } 
    if ((strCommand=="ON_OFF") || (strCommand=="SWITCH")) { Power_EFF = !Power_EFF; rassvet=0; } else
    if (strCommand=="P_ON") Power_EFF = true; else
    if (strCommand=="P_OFF") { Power_EFF = false; rassvet=0; }

    if (BRI==0) Power_EFF = false; 
    to_Matrix();
    EVERY_MS(1000) 
    if (hub.focused() && HUB_Update) {
      hub.sendUpdate("EFF", String(Real_EFF));
      hub.sendUpdate("sw_EFF", String(Power_EFF));
      hub.sendUpdate("BRI", String(BRI));
      hub.sendUpdate("SPD", String(SPD));
      hub.sendUpdate("SCA", String(SCA));
      hub.sendUpdate("CLR", String(CLR));
      HUB_Update=false;
    }
    if (Old_Power_EFF!=Power_EFF) {
       char send_udp[25];
       sprintf_P(send_udp, (const char *)F("WS2812 IS %s"), (Power_EFF) ? "ON":"OFF");
       module_parsig(255,send_udp);
    }

}
//--------------------------------------------------------
void get_WS2812() {
  char send_udp[25];
  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  sprintf_P(send_udp, (const char *)F("WS2812 IS %s"), (Power_EFF) ? "ON":"OFF");
  Udp.write(send_udp);
  Udp.endPacket();
}  
//--------------------------------------------------------
void HUB_module_pult_WS2812() {
  hub.WidgetSize(74);
  hub.Select_("EFF",&Real_EFF,F(NAME_EFF),F("Эффект"));
  hub.WidgetSize(26);
  hub.Switch_("sw_EFF",&Power_EFF,F("Включить")); 
}
//--------------------------------------------------------
void HUB_module_WS2812() {
  String st_tab="0";
  static uint8_t tab = 0;
  hub.WidgetSize(74);
  hub.Select_("EFF",&Real_EFF,F(NAME_EFF),F("Эффект"));
  eeprom_flag=false;
  hub.WidgetSize(26);
  hub.Switch_("sw_EFF",&Power_EFF,F("Включить")); 
  hub.WidgetSize(100);
  eeprom_flag |= hub.Slider_("BRI",&Matrix.BRI,GH_UINT8, F("Яркость"), 0, 255, 1);
  eeprom_flag |= hub.Slider_("SPD",&Matrix.SPD,GH_UINT8, F("Скорость"), 0, 255, 1);
  eeprom_flag |= hub.Slider_("SCA",&Matrix.SCA,GH_UINT8, F("Масштаб"), 0, 255, 1);
  eeprom_flag |= hub.Slider_("CLR",&Matrix.CLR,GH_UINT8, F("Цвет"), 0, 255, 1);
  hub.WidgetSize(50);
  eeprom_flag |= hub.Input(&Matrix.WIDTH, GH_UINT8, F("Ширина от 5 до 25"),0,F(REG_WIDTH));
  eeprom_flag |= hub.Input(&Matrix.HEIGHT, GH_UINT8, F("Высота от 5 до 25"),0,F(REG_HEIGHT));
  
  
   if (eeprom_flag) {
//      FS_UPDATE(WS2812_R);
      FS_UPDATE(Matrix);
      from_Matrix();
      CENTER_XY();
      eeprom_flag=false;
   }
   
}
//--------------------------------------------------------
void load_WS2812(){

}


//--------------------------------------------------------
// Эффекты
//--------------------------------------------------------
// Будильник Рассвет
#define DAWN_BRIGHT   200
void Rassvet() {
 static CHSV dawnColor = CHSV(0, 0, 0);                                    // цвет "рассвета"
 static CHSV dawnColorMinus1 = CHSV(0, 0, 0);                              // для большей плавности назначаем каждый новый цвет только 1/10 всех диодов; каждая следующая 1/10 часть будет "оставать" на 1 шаг
 static CHSV dawnColorMinus2 = CHSV(0, 0, 0);
 static CHSV dawnColorMinus3 = CHSV(0, 0, 0);
 static CHSV dawnColorMinus4 = CHSV(0, 0, 0);
 static CHSV dawnColorMinus5 = CHSV(0, 0, 0);
 static uint8_t dawnCounter = 0;                                           // счётчик первых 10 шагов будильника

 uint32_t step_rassvet=uint32_t(60000/255*length_rassvet);
 EVERY_MS(step_rassvet) {
  uint8_t dawnPosition = rassvet++;
//  DEBUGLN(step_rassvet);
//  DEBUGLN(dawnPosition);
  dawnColorMinus5 = dawnCounter > 4 ? dawnColorMinus4 : dawnColorMinus5;
  dawnColorMinus4 = dawnCounter > 3 ? dawnColorMinus3 : dawnColorMinus4;
  dawnColorMinus3 = dawnCounter > 2 ? dawnColorMinus2 : dawnColorMinus3;
  dawnColorMinus2 = dawnCounter > 1 ? dawnColorMinus1 : dawnColorMinus2;
  dawnColorMinus1 = dawnCounter > 0 ? dawnColor : dawnColorMinus1;
  dawnColor = CHSV(map(dawnPosition, 0, 255, 10, 35),
                   map(dawnPosition, 0, 255, 255, 170),
                   map(dawnPosition, 0, 255, 10, DAWN_BRIGHT));
  dawnCounter++;
  for (uint16_t i = 0U; i < NUM_LEDS; i++)
  {
    if (i % 6 == 0) leds[i] = dawnColor;                          // 1я 1/10 диодов: цвет текущего шага
    if (i % 6 == 1) leds[i] = dawnColorMinus1;                    // 2я 1/10 диодов: -1 шаг
    if (i % 6 == 2) leds[i] = dawnColorMinus2;                    // 3я 1/10 диодов: -2 шага
    if (i % 6 == 3) leds[i] = dawnColorMinus3;                    // 3я 1/10 диодов: -3 шага
    if (i % 6 == 4) leds[i] = dawnColorMinus4;                    // 3я 1/10 диодов: -4 шага
    if (i % 6 == 5) leds[i] = dawnColorMinus5;                    // 3я 1/10 диодов: -5 шагов
  }
  FastLED.setBrightness(255);
  delay(1);
  FastLED.show();
 }
}
// ============= Эффекты Noise в массиве палитр ===============
void NoiseRoutine() {
  SetPallete();
  currentPalette = *curPalette;
  colorLoop = SCA % 2;
  fillNoiseLED();
}
//--------------------------------------------------------
// Радуга по кругу
void rainbowHorVertRoutine(bool isVertical) {
  for (uint8_t i = 0U; i < (isVertical ? WIDTH : HEIGHT); i++) {
    CHSV thisColor = CHSV((uint8_t)(hue + i * (SCA % 86U)/2), 255U, 255U);

    for (uint8_t j = 0U; j < (isVertical ? HEIGHT : WIDTH); j++)
      leds[XY(isVertical ? i : j, isVertical ? j : i)] = thisColor;
  }
}

void effect_rainbow() {
  hue += 4U;
  if (SCA < 86U)           
    rainbowHorVertRoutine(true);
  else if (SCA > 172U)      
    rainbowHorVertRoutine(false);
  else                                          // для масштабов посередине
    for (uint8_t i = 0U; i < WIDTH; i++)
      for (uint8_t j = 0U; j < HEIGHT; j++)
      {
        float twirlFactor = 9.0F * ((SCA - 86) / 400.0F);    // на сколько оборотов будет закручена матрица, [0..3]

        CRGB thisColor = CHSV((uint8_t)(hue + ((float)WIDTH / (float)HEIGHT * i + j * twirlFactor) * ((float)255 / (float)maxDim)), 255U, 255U);
        
        leds[XY(i, j)] = thisColor;
      }
   FastLED.show();
}
// ============= Огонь 2020 ===============
// (c) SottNick Переработано Shaitan
#define SPARKLES_NUM  (WIDTH / 8U) // не более чем  enlargedOBJECT_MAX_COUNT (WIDTH * 2)
#define trackingOBJECT_MAX_COUNT                         (10U)  // максимальное количество отслеживаемых объектов (очень влияет на расход памяти)
uint8_t shiftHue[MAX_HEIGHT];
float   trackingObjectPosX[trackingOBJECT_MAX_COUNT];
float   trackingObjectPosY[trackingOBJECT_MAX_COUNT];
uint16_t ff_x, ff_y, ff_z;                         // большие счётчики
//-----------------------------------------
void fire2020Routine2() {
  uint8_t deltaValue;
  
  deltaValue=map(CLR,0,255,0,sizeof(firePalettes)/sizeof(TProgmemRGBPalette16 *)-1);
  curPalette = firePalettes[deltaValue];
  
  deltaValue = (((SCA - 1U) % 11U + 1U) << 4U) - 8U; // ширина языков пламени (масштаб шума Перлина)
  uint8_t deltaHue = map(deltaValue, 8U, 168U, 8U, 84U); // высота языков пламени должна уменьшаться не так быстро, как ширина
  uint8_t step = map(255U - deltaValue, 87U, 247U, 4U, 32U); // вероятность смещения искорки по оси ИКС
  for (uint8_t j = 0; j < HEIGHT; j++) {
    shiftHue[j] = (HEIGHT - 1 - j) * 255 / (HEIGHT - 1); // init colorfade table
  }
  for (uint8_t i = 0; i < SPARKLES_NUM; i++) {
    trackingObjectPosY[i] = random8(HEIGHT);
    trackingObjectPosX[i] = random8(WIDTH);
  }
  for (uint8_t i = 0; i < WIDTH; i++) {
    for (uint8_t j = 0; j < HEIGHT; j++) {
      nblend(leds[XY(i, HEIGHT - 1U - j)], ColorFromPalette(*curPalette, qsub8(inoise8(i * deltaValue, (j + ff_y + random8(2)) * deltaHue, ff_z), shiftHue[j]), 255U), 160U);
    }
  }

  for (uint8_t i = 0; i < SPARKLES_NUM; i++) {
    if (trackingObjectPosY[i] > 3U) {
      leds[XY(trackingObjectPosX[i], trackingObjectPosY[i])] = leds[XY(trackingObjectPosX[i], 3U)];
      leds[XY(trackingObjectPosX[i], trackingObjectPosY[i])].fadeToBlackBy( trackingObjectPosY[i] * 2U );
    }
    trackingObjectPosY[i]++;
    if (trackingObjectPosY[i] >= HEIGHT) {
      trackingObjectPosY[i] = random8(4U);
      trackingObjectPosX[i] = random8(WIDTH);
    }
    if (!random8(step))
      trackingObjectPosX[i] = (WIDTH + (uint8_t)trackingObjectPosX[i] + 1U - random8(3U)) % WIDTH;
  }
  ff_y++;
  if (ff_y & 0x01)
    ff_z++;
  FastLED.show();
}
// ============= ЭФФЕКТ ДОЖДЬ ===============
// (c) @Shaitan
void RainRoutine(uint8_t eff_mode)
{
  SetPallete();
  FOR_i(0,WIDTH)
  {
    // заполняем случайно верхнюю строку
    CRGB thisColor = getPixColorXY(i, HEIGHT - 1U);
    if ((uint32_t)thisColor == 0U)
    {
      if (random8(0, 80-SCA/4) == 0U)
      {
        thisColor = CHSV(CLR + random(0, 16), 255, 255); // Цветной дождь
        if (eff_mode==1) thisColor = CHSV(random(0, 9) * 28, 255U, 255U); // Радужный дождь
        if (eff_mode==2) thisColor = 0xE0FFFF - 0x101010 * random(0, 4); // Снег
        if (eff_mode==3) thisColor = ColorFromPalette(*curPalette, random8(), 255);
        drawPixelXY(i, HEIGHT - 1U, thisColor); 
      }
    }
    else
      leds[XY(i, HEIGHT - 1U)] -= CHSV(0, 0, random(96, 128));
  }
  // сдвигаем всё вниз
  FOR_i(0,WIDTH) FOR_j(0,HEIGHT-1) drawPixelXY(i, j, getPixColorXY(i, j + 1U));
  FastLED.show();
}

// ============= Эффект Цветные драже ===============
// (c) SottNick
//по мотивам визуала эффекта by Yaroslaw Turbin 14.12.2020
//https://vk.com/ldirko программный код которого он запретил брать

void sandRoutine() {
  static uint8_t pcnt;                                      // какой-то счётчик какого-то прогресса
  // если насыпалось уже достаточно, бахаем рандомные песчинки
  uint8_t temp = map8(random8(), SCA, 255U);
  if (pcnt >= map8(temp, 2U, HEIGHT - 3U)) {
    temp = HEIGHT + 1U - pcnt;
    if (!random8(4U)) // иногда песка осыпается до половины разом
      if (random8(2U))
        temp = 2U;
      else
        temp = 3U;
    for (uint8_t y = 0; y < pcnt; y++)
      for (uint8_t x = 0; x < WIDTH; x++)
        if (!random8(temp))
          leds[XY(x, y)] = 0;
  }

  pcnt = 0U;
  // осыпаем всё, что есть на экране
  for (uint8_t y = 1; y < HEIGHT; y++)
    for (uint8_t x = 0; x < WIDTH; x++)
      if (leds[XY(x, y)])                                                          // проверяем для каждой песчинки
        if (!leds[XY(x, y - 1)]) {                                                 // если под нами пусто, просто падаем
          leds[XY(x, y - 1)] = leds[XY(x, y)];
          leds[XY(x, y)] = 0;
        }
        else if (x > 0U && !leds[XY(x - 1, y - 1)] && x < WIDTH - 1 && !leds[XY(x + 1, y - 1)]) { // если под нами пик
          if (random8(2U))
            leds[XY(x - 1, y - 1)] = leds[XY(x, y)];
          else
            leds[XY(x - 1, y - 1)] = leds[XY(x, y)];
          leds[XY(x, y)] = 0;
          pcnt = y - 1;
        }
        else if (x > 0U && !leds[XY(x - 1, y - 1)]) {                              // если под нами склон налево
          leds[XY(x - 1, y - 1)] = leds[XY(x, y)];
          leds[XY(x, y)] = 0;
          pcnt = y - 1;
        }
        else if (x < WIDTH - 1 && !leds[XY(x + 1, y - 1)]) {                       // если под нами склон направо
          leds[XY(x + 1, y - 1)] = leds[XY(x, y)];
          leds[XY(x, y)] = 0;
          pcnt = y - 1;
        }
        else                                                                       // если под нами плато
          pcnt = y;

  // эмиттер новых песчинок
  if (!leds[XY(CENTER_X_MINOR, HEIGHT - 2)] && !leds[XY(CENTER_X_MAJOR, HEIGHT - 2)] && !random8(3)) {
    temp = random8(2) ? CENTER_X_MINOR : CENTER_X_MAJOR;
    leds[XY(temp, HEIGHT - 1)] = CHSV(random8(), 255U, 255U);
  }
  FastLED.show();
}

// =====================================
//            Flower Ruta
//    © Stepko and © Sutaburosu
//     Adaptation © SlingMaster
//             22/05/22
// =====================================
/* --------------------------------- */
void FlowerRuta() {
  static uint8_t PETALS;
  static uint32_t t;
  PETALS = map(SCA, 1, 255, 2U, 8U);
  
    for (int8_t x = -CENTER_X_MAJOR; x < CENTER_X_MAJOR; x++)
      for (int8_t y = -CENTER_Y_MAJOR; y < CENTER_Y_MAJOR; y++) {
        noise3d[0][x + CENTER_X_MAJOR][y + CENTER_Y_MAJOR] = (atan2(x, y) / PI) * 128 + 127; // thanks ldirko
        noise3d[1][x + CENTER_X_MAJOR][y + CENTER_Y_MAJOR] = hypot(x, y);                    // thanks Sutaburosu
      }
  t++;
  for (uint8_t x = 0; x < WIDTH; x++) {
    for (uint8_t y = 0; y < HEIGHT; y++) {
      byte angle = noise3d[0][x][y];
      byte radius = noise3d[1][x][y];
      leds[XY(x, y)] = CHSV(t + radius * (255 / WIDTH), 255, sin8(sin8(t + angle * PETALS + ( radius * (255 / WIDTH))) + t * 4 + sin8(t * 4 - radius * (255 / WIDTH)) + angle * PETALS));
    }
  }
  FastLED.show();
}
//--------------------------------
void dimAll(uint8_t value, CRGB *LEDarray = leds) {
  nscale8(LEDarray, NUM_LEDS, value);
}
// ------------- конфетти --------------
#define FADE_OUT_SPEED        (70U)                         // скорость затухания
void sparklesRoutine() {
  for (uint8_t i = 0; i < SCA; i++)
  {
    uint8_t x = random8(WIDTH);
    uint8_t y = random8(HEIGHT);
    if (getPixColorXY(x, y) == 0U)
    {
//      if (random8(5)==0) 
        leds[XY(x, y)] = CHSV(random8(), 255U, random8(150,255));
    }
  }
  dimAll(256U - FADE_OUT_SPEED);
  FastLED.show();
}
// ------------------------------ ЭФФЕКТ МЕРЦАНИЕ ----------------------
// (c) SottNick

#define MAX_twink 100
#define TWINKLES_SPEEDS 5     // скорость мерцания
struct {
  uint8_t x;
  uint8_t y;
  uint8_t col;
  uint8_t bri;
  int8_t dir;
} twink[MAX_twink];


void twinklesRoutine() {
  SetPallete();
  uint8_t deltaValue = (SCA / 20);  // вероятность пикселя загореться от 1/1 до 1/11
  uint8_t col_twink=map(SCA,0,255,1,MAX_twink);
  dimAll(240);
  FOR_i(0,col_twink)
    if (twink[i].bri == 0) {
      if (random8(5)==0) {
        uint8_t le_x=random8(WIDTH);
        uint8_t le_y=random8(HEIGHT);
        if (getPixColorXY(le_x,le_y)==0) {
          twink[i].x=le_x;
          twink[i].y=le_y;
          twink[i].bri = 1;
          twink[i].col=random8();
          twink[i].dir = random8(TWINKLES_SPEEDS)+5;
        }
      }
    } else {
    if (twink[i].dir>0) {
        if (255-twink[i].bri > twink[i].dir+20) twink[i].bri+=(twink[i].dir+20);
        else twink[i].dir=-twink[i].dir;
      } else {
        if (twink[i].bri > -twink[i].dir) twink[i].bri+=twink[i].dir;
        else twink[i].bri=0;
      }
    }

  FOR_i(0,col_twink)
      leds[XY(twink[i].x,twink[i].y)] = ColorFromPalette(*curPalette, twink[i].col, twink[i].bri);

  FastLED.show();
}
//-----------------------------------------------
// ------------- Звездопад -------------

void stormRoutine(uint8_t eff_mode) {
  SetPallete();
  FOR_i(0,WIDTH)
  {
    // заполняем случайно верхнюю строку
    CRGB thisColor = CHSV(CLR + random(0, 16), 255, 255); // Цветной дождь
    if (!getPixColorXY(wrapX(i), HEIGHT - 1U) &&
        !getPixColorXY(wrapX(i + 1U), HEIGHT - 1U) &&
        !getPixColorXY(wrapX(i - 1U), HEIGHT - 1U)) {
      if (random8(0, 80-SCA/4) == 0U)
      {
        if (eff_mode==1) thisColor = CHSV(random(0, 9) * 28, 255U, 255U); // Радужный дождь
        if (eff_mode==2) thisColor = 0xE0FFFF - 0x101010 * random(0, 4); // Снег
        if (eff_mode==3) thisColor = ColorFromPalette(*curPalette, random8(), 255);
        drawPixelXY(i, HEIGHT - 1U, thisColor); 
      }
    }
    else
      leds[XY(i, HEIGHT - 1U)] -= CHSV(0, 0, random(96, 128));
  }
  
  // сдвигаем по диагонали
  for (uint8_t y = 0U; y < HEIGHT - 1U; y++)
  {
    for (uint8_t x = 0; x < WIDTH; x++)
    {
      drawPixelXY(wrapX(x + 1U), y, getPixColorXY(x, y + 1U));
    }
  }

  // уменьшаем яркость верхней линии, формируем "хвосты"
  FOR_i(0,WIDTH) leds[XY(i, HEIGHT - 1U)] -= CHSV(0, 0, random(96, 128));    
  FastLED.show();
}

// =============== Эффект Lumenjer ================
// по мотивам (c) SottNick
#define MAX_DIAG 5
struct struct_dxdy{
  uint8_t x = random8(WIDTH);
  uint8_t y = random8(HEIGHT);
  int8_t dx = random(2)*2-1;
  int8_t dy = random(2)*2-1;
};
struct_dxdy dxdy[MAX_DIAG];

void lumenjerRoutine() {
  
  int16_t DIMSPEED = 254U - 1500U / WIDTH / HEIGHT;
  static uint8_t step;
  dimAll(DIMSPEED);
  SetPallete();
  FOR_i(0,MAX_DIAG) {
    dxdy[i].dx = random8(3) ? dxdy[i].dx : -dxdy[i].dx;
    dxdy[i].dy = random8(3) ? dxdy[i].dy : -dxdy[i].dy;
    if (WIDTH % 2 == 0 && HEIGHT % 2 == 0)
       dxdy[i].x = (WIDTH + dxdy[i].x + dxdy[i].dx * (bool)random8(64)) % WIDTH;
    else
       dxdy[i].x = (WIDTH + dxdy[i].x + dxdy[i].dx) % WIDTH;
    dxdy[i].y = (HEIGHT + dxdy[i].y + dxdy[i].dy) % HEIGHT;
    leds[XY(dxdy[i].x, dxdy[i].y)] += ColorFromPalette(*curPalette, i*SCA+step);
  }
  step++;
  FastLED.show();
}

//--------------------------
// ************* СЛУЖЕБНЫЕ *************
//--------------------------------------------------------
// Утилиты для эффектов
//--------------------------------------------------------
void CENTER_XY() {
  CENTER_X_MINOR =  (WIDTH / 2) -  ((WIDTH - 1) & 0x01); // центр матрицы по ИКСУ, сдвинутый в меньшую сторону, если ширина чётная
  CENTER_Y_MINOR = (HEIGHT / 2) - ((HEIGHT - 1) & 0x01); // центр матрицы по ИГРЕКУ, сдвинутый в меньшую сторону, если высота чётная
  CENTER_X_MAJOR =   WIDTH / 2  + (WIDTH % 2);           // центр матрицы по ИКСУ, сдвинутый в большую сторону, если ширина чётная
  CENTER_Y_MAJOR =  HEIGHT / 2  + (HEIGHT % 2);          // центр матрицы по ИГРЕКУ, сдвинутый в большую сторону, если высота чётная
}
void SaluteFadeAll(uint8_t val)
{ 
  FOR_i(0,NUM_LEDS) leds[i]-=CHSV(0,0,val);
}
//--------------------------------------------------------

void drawPixelXY(int8_t x, int8_t y, CRGB clr)
{
  if (x < 0 || x > (WIDTH - 1) || y < 0 || y > (HEIGHT - 1)) return;
  leds[XY(x, y)] = clr;
}

//--------------------------
uint16_t XY(uint8_t x, uint8_t y)
{
  if (x & 0x01)              
    return (x * HEIGHT + HEIGHT - y - 1); 
  else                                                  
    return (x * HEIGHT + y);
}

//--------------------------

void fillNoiseLED()
{
  uint8_t dataSmoothing = 0;
  if (speed < 50)
  {
    dataSmoothing = 200 - (speed * 4);
  }
  for (uint8_t i = 0; i < MAX_DIMENSION; i++)
  {
    int32_t ioffset = scale * i;
    for (uint8_t j = 0; j < MAX_DIMENSION; j++)
    {
      int32_t joffset = scale * j;

      uint8_t data = inoise8(x + ioffset, y + joffset, z);

      data = qsub8(data, 16);
      data = qadd8(data, scale8(data, 39));

      if (dataSmoothing)
      {
        uint8_t olddata = noise[i][j];
        uint8_t newdata = scale8( olddata, dataSmoothing) + scale8( data, 256 - dataSmoothing);
        data = newdata;
      }

      noise[i][j] = data;
    }
  }
  z += speed;

  // apply slow drift to X and Y, just for visual variation.
  x += speed / 8;
  y -= speed / 16;

  for (uint8_t i = 0; i < WIDTH; i++)
  {
    for (uint8_t j = 0; j < HEIGHT; j++)
    {
      uint8_t index = noise[j][i];
      uint8_t bri =   noise[i][j];
      // if this palette is a 'loop', add a slowly-changing base value
      if ( colorLoop)
      {
        index += hue;
      }
      // brighten up, as the color palette itself often contains the
      // light/dark dynamic range desired
      if ( bri > 127 )
      {
        bri = 255;
      }
      else
      {
        bri = dim8_raw( bri * 2);
      }
      CRGB color = ColorFromPalette( currentPalette, index, bri);      
      
//      drawPixelXY(i, j, color);                             //leds[getPixelNumber(i, j)] = color;
       if (!(i < 0 || i > (WIDTH - 1) || j < 0 || j > (HEIGHT - 1))) 
         leds[XY(i, j)] = color;

    }
  }
  hue += 1;
  FastLED.show();
}

void fillnoise8()
{
  for (uint8_t i = 0; i < MAX_DIMENSION; i++)
  {
    int32_t ioffset = scale * i;
    for (uint8_t j = 0; j < MAX_DIMENSION; j++)
    {
      int32_t joffset = scale * j;
      noise[i][j] = inoise8(x + ioffset, y + joffset, z);
    }
  }
  z += speed;
//  z ++; 
}
//--------------------------------
uint32_t getPixColorXY(uint8_t x, uint8_t y)
{
  return getPixColor(XY(x, y));
}
//--------------------------------
uint32_t getPixColor(uint32_t thisPixel)
{
  if (thisPixel > NUM_LEDS - 1) return 0;
  return (((uint32_t)leds[thisPixel].r << 16) | ((uint32_t)leds[thisPixel].g << 8 ) | (uint32_t)leds[thisPixel].b); // а почему не просто return (leds[thisPixel])?
//  return leds[thisPixel];
}

//--------------------------------
void SetPallete() { 
  uint8_t deltaValue=map(CLR,0,255,0,sizeof(FullPalettes)/sizeof(TProgmemRGBPalette16 *)-1);
  curPalette = FullPalettes[deltaValue];
}  
//--------------------------------
uint8_t wrapX(int8_t x) {
  return (x + WIDTH) % WIDTH;
}
//--------------------------------
uint8_t wrapY(int8_t y) {
  return (y + HEIGHT) % HEIGHT;
}
#endif
#endif
